SurfaceGenerator
Date: 2019-10-22

org.jmol.jvxl.readers

## Class SurfaceGenerator

- java.lang.Object
- - org.jmol.jvxl.readers.SurfaceGenerator

-     public class SurfaceGenerator
      extends java.lang.Object

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `AtomDataServer` | `atomDataServer`
    `javajs.util.BS` | `bsVdw`
    `private int` | `colorPtr`
    `java.lang.String` | `fileType`
    `boolean` | `isValid`
    `JvxlData` | `jvxlData`
    `MarchingSquares` | `marchingSquares`
    `MeshData` | `meshData`
    `MeshDataServer` | `meshDataServer`
    `private javajs.util.OC` | `out`
    `Parameters` | `params`
    `private javajs.util.P3` | `ptRef`
    `private java.lang.Object` | `readerData`
    `private SurfaceReader` | `surfaceReader`
    `private javajs.util.V3` | `vAB`
    `java.lang.String` | `version`
    `private javajs.util.V3` | `vNorm`
    `VolumeData` | `volumeDataTemp`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `SurfaceGenerator(AtomDataServer atomDataServer, MeshDataServer meshDataServer, MeshData meshData, JvxlData jvxlData)`

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `addRequiredFile(java.lang.String fileName)`
    `(package private) void` | `colorIsosurface()`
    `private float` | `distanceVerticalToPlane(float x, float y, javajs.util.P3 pta, javajs.util.P3 ptb, javajs.util.P3 ptc)`
    `(package private) void` | `fillAtomData(AtomData atomData, int mode)`
    `private static float` | `findNearestThreePoints(float x, float y, float[][] xyz, int[] result)`
    `private void` | `generateSurface()`
    `private void` | `getFunctionZfromXY()`
    `private static java.lang.Object` | `getInterface(java.lang.String name)`
    `javajs.util.V3[]` | `getOriginVaVbVc()`
    `java.lang.Object` | `getProperty(java.lang.String property, int index)` only called from org.openscience.jvxl.Jvxl.main
    `(package private) java.lang.Object` | `getReaderData()`
    `private void` | `getSurfaceSets()`
    `(package private) void` | `initializeIsosurface()`
    `void` | `initState()`
    `(package private) void` | `log(java.lang.String msg)`
    `private void` | `mapSurface()`
    `private SurfaceReader` | `newReader(java.lang.String name)`
    `private SurfaceReader` | `newReaderBr(java.lang.String name, java.io.BufferedReader br)`
    `private void` | `processState()`
    `private SurfaceReader` | `setFileData(Viewer vwr, java.lang.Object value)`
    `void` | `setJvxlData(JvxlData jvxlData)`
    `java.lang.String` | `setLcao()`
    `(package private) void` | `setOutputChannel(javajs.api.GenericBinaryDocument binaryDoc, javajs.util.OC out)`
    `boolean` | `setProp(java.lang.String propertyName, java.lang.Object value, javajs.util.BS bs)`
    `private boolean` | `setReader()`
    `void` | `setRequiredFile(java.lang.String oldName, java.lang.String fileName)`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### params

          public Parameters params

    - #### jvxlData

          public JvxlData jvxlData

    - #### meshData

          public MeshData meshData

    - #### volumeDataTemp

          public VolumeData volumeDataTemp

    - #### meshDataServer

          public MeshDataServer meshDataServer

    - #### atomDataServer

          public AtomDataServer atomDataServer

    - #### marchingSquares

          public MarchingSquares marchingSquares

    - #### version

          public java.lang.String version

    - #### isValid

          public boolean isValid

    - #### fileType

          public java.lang.String fileType

    - #### bsVdw

          public javajs.util.BS bsVdw

    - #### colorPtr

          private int colorPtr

    - #### surfaceReader

          private SurfaceReader surfaceReader

    - #### out

          private javajs.util.OC out

    - #### readerData

          private java.lang.Object readerData

    - #### vAB

          private final javajs.util.V3 vAB

    - #### vNorm

          private final javajs.util.V3 vNorm

    - #### ptRef

          private final javajs.util.P3 ptRef

  - ### Constructor Detail

    - #### SurfaceGenerator

          public SurfaceGenerator(AtomDataServer atomDataServer,
                                  MeshDataServer meshDataServer,
                                  MeshData meshData,
                                  JvxlData jvxlData)

  - ### Method Detail

    - #### setJvxlData

          public void setJvxlData(JvxlData jvxlData)

    - #### setProp

          public boolean setProp(java.lang.String propertyName,
                                 java.lang.Object value,
                                 javajs.util.BS bs)

      Parameters:
        `propertyName` -
        `value` -
        `bs` -
      Returns:
        TRUE if handled

    - #### newReader

          private SurfaceReader newReader(java.lang.String name)

    - #### newReaderBr

          private SurfaceReader newReaderBr(java.lang.String name,
                                            java.io.BufferedReader br)

    - #### getInterface

          private static java.lang.Object getInterface(java.lang.String name)

    - #### getSurfaceSets

          private void getSurfaceSets()

    - #### processState

          private void processState()

    - #### setReader

          private boolean setReader()

    - #### generateSurface

          private void generateSurface()

    - #### mapSurface

          private void mapSurface()

    - #### colorIsosurface

          void colorIsosurface()

    - #### getProperty

          public java.lang.Object getProperty(java.lang.String property,
                                              int index)

      only called from org.openscience.jvxl.Jvxl.main
      Parameters:
        `property` -
        `index` -
      Returns:
        Object

    - #### setFileData

          private SurfaceReader setFileData(Viewer vwr,
                                            java.lang.Object value)

      Parameters:
        `vwr` -
        `value` -
      Returns:
        SurfaceReader

    - #### getReaderData

          java.lang.Object getReaderData()

    - #### initializeIsosurface

          void initializeIsosurface()

    - #### initState

          public void initState()

    - #### setLcao

          public java.lang.String setLcao()

    - #### getFunctionZfromXY

          private void getFunctionZfromXY()

    - #### distanceVerticalToPlane

          private float distanceVerticalToPlane(float x,
                                                float y,
                                                javajs.util.P3 pta,
                                                javajs.util.P3 ptb,
                                                javajs.util.P3 ptc)

    - #### findNearestThreePoints

          private static float findNearestThreePoints(float x,
                                                      float y,
                                                      float[][] xyz,
                                                      int[] result)

    - #### addRequiredFile

          public void addRequiredFile(java.lang.String fileName)

    - #### setRequiredFile

          public void setRequiredFile(java.lang.String oldName,
                                      java.lang.String fileName)

    - #### log

          void log(java.lang.String msg)

    - #### setOutputChannel

          void setOutputChannel(javajs.api.GenericBinaryDocument binaryDoc,
                                javajs.util.OC out)

    - #### fillAtomData

          void fillAtomData(AtomData atomData,
                            int mode)

    - #### getOriginVaVbVc

          public javajs.util.V3[] getOriginVaVbVc()